﻿if not LibStub("LibPeriodicTable-3.1", true) then error("LibPeriodicTable-3.1 must be loaded before data") end
local PT = LibStub("LibPeriodicTable-3.1", true)

function Liquid_Wealth:Scan(startbag, endbag)
	local bagLink = ""
	local bagName = ""
	local bagTexturePath = ""

	if (startbag == endbag) then
		--self:Print("Start Bag == End Bag")
		if (GetContainerNumSlots(startbag) >= 1) and (startbag > 0) then --Check to see if player had bag equipped, and to skip bank and backpack
			local invID = ContainerIDToInventoryID(startbag);
			bagLink = GetInventoryItemLink("player", invID);
			local itemName, itemLink, _, _, _, _, _, _, _, itemTexture, _ = GetItemInfo(bagLink)
			bagTexturePath = itemTexture
			bagName = itemName
		elseif startbag == -1 then --Bank
			bagLink = "Bank";
			bagTexturePath = "Interface\\Icons\\INV_Misc_Bag_08"
			bagName = "Bank"
		elseif startbag == 0 then --Backpack
			bagLink = "Backpack"
			bagTexturePath = "Interface\\Icons\\INV_Misc_Bag_08"
			bagName = "Backpack"
		elseif startbag ==-3 then
			bagLink = "ReagentBank"
			bagTexturePath = "Interface\\Icons\\INV_Misc_Bag_08"
			bagName = "ReagentBank"
		else
			bagLink = "NONE" -- Set the Item ID to none if the player didn't buy a bank/equipped bag or bank slot.
			bagTexturePath = "NONE"
			bagName = "NONE"
		end
		local bagTotalVendor,bagTotalAuction = Liquid_Wealth:NewGetBagValue(startbag)
		Liquid_Wealth.db.realm.toon[UnitName("player")].bagID[startbag] = Liquid_Wealth:ConvItemDataToDB(bagLink, bagTexturePath, bagName, bagTotalVendor, bagTotalAuction)
		--Liquid_Wealth.db.realm.toon[UnitName("player")].bagID[startbag] = Liquid_Wealth:ConvItemDataToDB(bagLink, bagTexturePath, bagName, Liquid_Wealth:GetBagValueVender(startbag), Liquid_Wealth:GetBagValueAuction(startbag));
		--Liquid_Wealth:ScanFilters(startbag)
	else
		--self:Print("Start Bag Is Not == End Bag")
		for bagId = startbag, endbag do -- Add up the value of each bag's contents
			if (GetContainerNumSlots(bagId) >= 1) and (bagId > 0) then --Check to see if player had bag equipped, and to skip bank and backpack
				local invID = ContainerIDToInventoryID(bagId);
				bagLink = GetInventoryItemLink("player", invID);
				local itemName, itemLink, _, _, _, _, _, _, _, itemTexture, _ = GetItemInfo(bagLink)
				bagTexturePath = itemTexture
				bagName = itemName
			elseif bagId == -1 then --Bank
				bagLink = "Bank";
				bagTexturePath = "Interface\\Icons\\INV_Misc_Bag_08"
				bagName = "Bank"
			elseif bagId == 0 then --Backpack
				bagLink = "Backpack";
				bagTexturePath = "Interface\\Icons\\INV_Misc_Bag_08"
				bagName = "Backpack"
			elseif startbag ==-3 then
				bagLink = "ReagentBank"
				bagTexturePath = "Interface\\Icons\\INV_Misc_Bag_08"
				bagName = "ReagentBank"
			else
				bagLink = "NONE" -- Set the Item ID to none if the player didn't buy a bank/equipped bag or bank slot.
				bagTexturePath = "NONE"
				bagName = "NONE"
			end
			local bagTotalVendor,bagTotalAuction = Liquid_Wealth:NewGetBagValue(bagId)
			Liquid_Wealth.db.realm.toon[UnitName("player")].bagID[bagId] = Liquid_Wealth:ConvItemDataToDB(bagLink, bagTexturePath, bagName, bagTotalVendor, bagTotalAuction);
			--Liquid_Wealth.db.realm.toon[UnitName("player")].bagID[bagId] = Liquid_Wealth:ConvItemDataToDB(bagLink, bagTexturePath, bagName, Liquid_Wealth:GetBagValueVender(bagId), Liquid_Wealth:GetBagValueAuction(bagId));
			--Liquid_Wealth:ScanFilters(bagId)
		end
	end
	
	Liquid_Wealth.db.realm.toon[UnitName("player")].playergold = GetMoney();
	--Liquid_Wealth.db.realm.toon[UnitName("player")].lastChecked = date("%m/%d/%y %I:%M:%S %p");
	Liquid_Wealth.db.realm.toon[UnitName("player")].lastChecked = time()
end

function Liquid_Wealth:NewGetBagValue(bagId)
	local bagTotalVendor = 0
	local bagTotalVendorFilter = 0
	local bagTotalAuction = 0
	local bagTotalAuctionFilter = 0
	local bagFilterTotal = 0
	local bagFilters={}
	
	local bagSlots = GetContainerNumSlots(bagId);
	
	if Liquid_Wealth.db.realm.toon[UnitName("player")].filters then
		for filter in pairs(Liquid_Wealth.db.realm.toon[UnitName("player")].filters) do
			--print(filter)
			if not bagFilters[filter] then
				bagFilters[filter]={}
				bagFilters[filter].Vendor=0
				bagFilters[filter].Acution=0
			end
		end
	end	
	
	if (bagSlots > 0) then
		--print(bagId)
		for slot = 1, bagSlots do
			local itemLink = GetContainerItemLink(bagId, slot);
			if (itemLink) then
				local texture, itemCount, locked, quality, readable = GetContainerItemInfo(bagId, slot); -- Needed for itemCount
				local itemAuctionValue = 0
				local itemVendorValue = 0
				if Liquid_Wealth:IsItemSoulbound(bagId, slot) then
					
				else
					--------------------------------------------------------------------
					------------------------ Get Auction Value -------------------------
					--------------------------------------------------------------------
					if IsAddOnLoaded(Liquid_Wealth.db.profile.selectedAuctionAddon) then
						itemAuctionValue = self[self.AuctioneerAddons[string.lower(Liquid_Wealth.db.profile.selectedAuctionAddon)].func](self, itemLink); --Runs The Function In The List
						if (itemAuctionValue) then
							bagTotalAuction = bagTotalAuction + floor(itemCount * itemAuctionValue);
						end
					end
					--------------------------------------------------------------------
					------------------------- Get Vendor Value -------------------------
					--------------------------------------------------------------------
					itemVendorValue = Liquid_Wealth:GetItemValueVender(itemLink)
					if (itemVendorValue) then
						bagTotalVendor = bagTotalVendor + floor(itemCount * itemVendorValue)
					end
					---------------------------------------------------------------------
					------------------------- Get Filters -------------------------
					--------------------------------------------------------------------					
					if Liquid_Wealth.db.realm.toon[UnitName("player")].filters then
						for filter in pairs(Liquid_Wealth.db.realm.toon[UnitName("player")].filters) do
							--print("Current Filter: "..filter.." BagID: "..bagId)
							if (itemLink) and PT:ItemInSet(itemLink, Liquid_Wealth.db.realm.toon[UnitName("player")].filters[filter].ptsetings[1].setname) then
								--print(itemLink..":BagID: "..bagId..":Slot:"..slot..":".."Auction:"..itemAuctionValue.." : ".."Vendor:"..itemVendorValue)
								bagFilters[filter].Vendor=bagFilters[filter].Vendor+(itemCount*itemVendorValue)
								bagFilters[filter].Acution=bagFilters[filter].Acution+(itemCount*itemAuctionValue)
								--print("BagID: "..bagId.." | Vendor: "..bagFilters[filter].Vendor.." | Acution: "..bagFilters[filter].Acution)
							end
						end
					end
				end
			end
		end
	end

	if Liquid_Wealth.db.realm.toon[UnitName("player")].filters and bagFilters then
		for filter in pairs(bagFilters) do
			--print("bID: "..bagId.." | Filter: "..filter.." | Vendor: "..bagFilters[filter].Vendor.." | Acution: "..bagFilters[filter].Acution)
			if bagFilters[filter].Vendor and bagFilters[filter].Acution then
				Liquid_Wealth.db.realm.toon[UnitName("player")].filters[filter].bID[bagId]=bagFilters[filter].Vendor..":"..bagFilters[filter].Acution
			end
		end
	end
	
	--Liquid_Wealth.db.realm.toon[UnitName("player")].filters[filter].bagID[bagId]
	return bagTotalVendor,bagTotalAuction;
end

